// Copy the array item prolog and the body of an object in the array
// to "dst," thus forming a full object that's a copy of the body.
// Note that this does NOT ensure that "array" is an array - all the
// callers do that before calling this.
extern SatAddr makeItem(SatAddr array, SatAddr body, SatAddr dst);

// Common method for ARRAY and LNKARRY to get dimension for an array
// or linked array
int commonGetDimension(SatAddr array, int dimensionNumber);

// Worker function to find an element body from it's index numbers
// Returns zero on success.
// -10-n means the n'th index value is out of range.
int ARRAYgetElementBodyv(SatAddr array,
			 SatAddr *elementBody,
			 int idx1,
			 va_list argp);

// Common code for ARRAYitemSize and LNKARRYitemSize
int commonItemSize(SatAddr array, SatAddr addr);

// Read a bunch of indexes or dimensions from a vargs list and 
// return an array of them, or NULL if any dimension is larger than 0xffff.
// This is shared with lnkarry.c
int *commonGetDimensions(int numDimensions, int dim1, va_list argp);

// Copy the array item prolog and the body of an object in the array
// to "dst," thus forming a full object that's a copy of the body.
// Note that this does NOT ensure that "array" is an array - all the
// callers do that before calling this.
SatAddr commonMakeItem(SatAddr array, SatAddr body, SatAddr dst);

// Common code for ARRAYelementSize and LNKARRYelementSize
int commonElementSize(SatAddr array, SatAddr addr);
