#include <hpgcc49.h>
#include "hpobjects.h"


// Library routines.
// The only thing we do with a library and get its size.

//++
bool isLIB(SatAddr src)
{
    return (obProlog(src) == SAT_DOLIB);
}


int LIBnibbles(SatAddr src)
{
    // Programming in Saturn Assembly says that the size field excludes
    // the CRC, but evidence shows otherwise.

    if (!isLIB(src)) return -1;
    return 5 + sat_peek(src+5, 5);
}

